/*
 * Compiled with gcc 7.5.0
 * gcc -c -fpic parser.c
 * gcc -shared -o parser.so parser.o
 */

#include <stdarg.h>
#include <stdint.h>
#include <sys/types.h>
#include <stdio.h>

#define OPTION_ARRAY 15
#define OPTION_CONNECTION_TIMEOUT 3
#define OPTION_CONNECTION_LIMIT 2
#define OPTION_CONNECTION_MEMORY_LIMIT 1
#define OPTION_END 0

struct OptionItem
{
  int option;
  intptr_t value;
  void *ptr_value;
};


int parse_options_va (int count, va_list ap);

int parse_options (int count, ...)
{
  va_list ap;
  int ret;

  va_start (ap, count);
  ret = parse_options_va (count, ap);
  va_end (ap);
  return ret;
}


int parse_options_va (int count, va_list ap)
{
  int opt;
  int i;
  struct OptionItem *oa;

  while (OPTION_END != (opt = (int) va_arg (ap, int)))
    {
      switch (opt)
        {
        case OPTION_ARRAY:
            oa = va_arg (ap, struct OptionItem*);
            i = 0;
            while (OPTION_END != (opt = oa[i].option))
                {
                switch (opt)
                    {
                    case OPTION_CONNECTION_MEMORY_LIMIT:
                    case OPTION_CONNECTION_LIMIT:
                    case OPTION_CONNECTION_TIMEOUT:
                        // Match, but we don't care.
                        printf("Match of option: %d, with value: %d\n", opt, oa[i].value);
                        break;
                    default:
                        printf("NO match of option: %d, with value: %d\n", opt, oa[i].value);
                    }
                i++;
                if (i > count) return 999;
                }
            break;
        default:
            puts("No matched options.");
        }
    }
  puts("Finish.");
  return i;
}

int test ()
{
    int ret;

    struct OptionItem ops[] = {
    { OPTION_CONNECTION_TIMEOUT, 31, NULL },
    { OPTION_CONNECTION_LIMIT, 21, NULL },
    { OPTION_CONNECTION_MEMORY_LIMIT, 11, NULL},
    { OPTION_END, 0, NULL }
    };

    ret = parse_options(4, OPTION_ARRAY, ops, OPTION_END);

    return ret;
}
